#include <stdio.h>

typedef struct
{
	int a;
	int b;
}
ImaginaryType;

extern int symbol1;

extern int *symbol2;

extern int symbol3[];

extern ImaginaryType symbol4;

/*
 * Prema semantici C programskog jezika vrednost promenljive,
 * ciji je identifikator isti kao neki simbol,
 * nije jednaka vrednosti datog simbola vec je
 * jednaka sadrzaju u memoriji na adresi ukazanoj vrednoscu simbola.
 *
 * Vrednost simbola tj. adresu za koju je simbol vezan
 * moguce je dohvatiti preko identifikatora promenljive u C programskom jeziku
 * pomocu operatora za dohvatanje adrese (&)
 */

int main()
{
	printf("\n====================================================\n");
	// vrednost promenljive tipa (int) sa identifikatorom symbol1 (prema semantici C programskog jezika)
	printf("symbol1 = mem[offset(symbol1)] = %d \n", symbol1); 
	// vrednost simbola symbol1 tj. adresa na kojoj se cuva vrednost promenljive sa istim identifikatorom
	printf("&(symbol1) = offset(symbol1) = %p \n", &symbol1);

	printf("\n=====================================================\n");
	// vrednost promenljive tipa (int *) sa identifikatorom symbol2 (prema semantici C programskog jezika)
	printf("symbol2 = mem[offset(symbol2)] = %p \n", symbol2);
	// vrednost simbola symbol2 tj. adresa na kojoj se cuva vrednost promenljive sa istim identifikatorom
	printf("&(symbol2) = offset(symbol2) = %p \n", &symbol2);

	printf("\n=====================================================\n");
	for (int i = 0; i < 10; i++)
	{
		printf("symbol3[%d] = mem[offset(symbol3) + %d * sizeof(int)] = %d \n", i, i, symbol3[i]);
	}
	printf("&(symbol3) = offset(symbol3) = %p \n", &symbol3);

	printf("\n=====================================================\n");
	printf("symbol4.a = mem[offset(symbol4)] = %d \n", symbol4.a);
	printf("symbol4.b = mem[offset(symbol4) + sizeof(symbol4.a) + alignment(symbol4.b)] = %d \n", symbol4.b);
	printf("&(symbol4) = offset(symbol4) = %p \n\n", &symbol4);
    
    return 0;
}
